package letter;

import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JFrame;
import javax.swing.JLabel;

public class Editor extends JFrame implements KeyListener {

    private JLabel[] labs;
    private int lastLab;
    
    public Editor() {
        super();
        setSize(400, 200);
        setLocation(400, 200);
        labs = new JLabel[5];
        //setLayout(new GridLayout(5,1));
        setLayout(new FlowLayout());
        for (int i = 0; i < labs.length; i++) {
            labs[i] = new JLabel();
            //labs[i].setText(i + "");
            add(labs[i]);
        }
        lastLab = 0;
        
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setVisible(true);
    }
    
    public void keyPressed(KeyEvent ke) {
        // ignore
    }

    public void keyReleased(KeyEvent ke) {
        // ignore
    }

    public void keyTyped(KeyEvent ke) {
        String line = labs[lastLab].getText();
        line += ke.getKeyChar();
        labs[lastLab].setText(line);
        
        // Handle wrap-around when the line gets too long.
        if (labs[lastLab].getSize(null).width > 360) {
            // break at most recent space
            int endSp = line.lastIndexOf(' '); 
            String most = line.substring(0, endSp);
            String end = line.substring(endSp + 1);

            // Move to the next label, if where not at the end yet
            if (lastLab < labs.length - 1) {
                labs[lastLab].setText(most);
                lastLab++;
                labs[lastLab].setText(end);
            }
            // Other wise, discard the zeroth line,
            // move everyone back, and start a new one 
            // in the last label.
            else {
                for (int i = 0; i < labs.length - 2; i++)
                    labs[i].setText(labs[i+1].getText());
                labs[labs.length - 2].setText(most);
                labs[labs.length - 1].setText(end);
            }
        }

    }

    public static void main(String[] args) {
        Editor ed = new Editor();
        ed.setFocusable(true);
        ed.addKeyListener(ed);
    }
    
}
